import { AbstractModel } from "../model/AbstractModel";
import { IStartStop } from "../system/IStartStop";
export declare const getInjectionRegistry: () => InjectionRegistry;
export declare class InjectableInfo<T> {
    instance: T;
    environments?: string[];
}
export declare class InjectionTargetInfo {
    prototype: any;
    propertyKey: string;
    fieldConstructor: any;
}
export declare class InjectionRegistry {
    private injectionPerformed;
    private injectables;
    private targets;
    models: {
        new (): AbstractModel;
    }[];
    getInitableInjectables(): IStartStop[];
    registerTarget(info: InjectionTargetInfo): void;
    replaceTarget(oldPrototype: any, newPrototype: any): void;
    registerInjectable(constructor: {
        new (): any;
    }, environments?: string[]): void;
    replaceInjectable<T, K extends T>(instance: K, instanceClass: Function & {
        prototype: T;
    }): void;
    filterInjectable<T>(instanceSuperClass: Function & {
        prototype: T;
    }): T[];
    getInjectable<T>(instanceSuperClass: Function & {
        prototype: T;
    }, env?: string): T;
    performInjection(currentEnv?: string): void;
}
//# sourceMappingURL=injection.d.ts.map