import { Mime } from "../common/Mime";
import { StateMachineTransition } from "../common/StateMachineTransition";
import { AbstractModel } from "./AbstractModel";
export declare const Model: (config?: {
    /**
     * Name of the metadata, will be used as table name in database and exposing in DefaultHTTPResourceController.
     * Default will be lowercase version of the metadata itself. If metadata name is conflicted then add some package prefix to it, like pkg1_model_name
     */
    name?: string | undefined;
    /**
     * Description about this metadata.
     */
    description?: string | undefined;
} | undefined) => <T extends new (...args: any[]) => AbstractModel>(constructor: T) => T;
export declare const PK: (config?: {
    autoIncrement?: boolean | undefined;
} | undefined) => (prototype: AbstractModel, propertyKey: string) => void;
export declare const FK: (config: {
    model: {
        new (): AbstractModel;
    };
    cascade?: boolean;
}) => (prototype: AbstractModel, propertyKey: string) => void;
export declare const Indexing: (config?: {
    group?: string | undefined;
} | undefined) => (prototype: AbstractModel, propertyKey: string) => void;
export declare const BigInt: (config?: {
    isBigInt?: boolean | undefined;
} | undefined) => (prototype: AbstractModel, propertyKey: string) => void;
export declare const Unique: () => (prototype: AbstractModel, propertyKey: string) => void;
export declare const ServerValue: () => (prototype: AbstractModel, propertyKey: string) => void;
export declare const Default: (config: {
    value: any;
}) => (prototype: any, propertyKey: string) => void;
export declare const URI: (config?: {
    mimeType: Mime;
} | undefined) => (prototype: any, propertyKey: string) => void;
export declare const StateMachine: <T>(config: {
    transition: StateMachineTransition<T>[];
}) => (prototype: AbstractModel, propertyKey: string) => void;
export declare const Searchable: () => (prototype: AbstractModel, propertyKey: string) => void;
export declare const Timestamp: () => (prototype: AbstractModel, propertyKey: string) => void;
export declare const Text: (length?: number | undefined) => (prototype: AbstractModel, propertyKey: string) => void;
export declare const ServerModify: <T>(modifyFn?: ((value: T) => T) | undefined) => (prototype: AbstractModel, propertyKey: string) => void;
//# sourceMappingURL=decorator.d.ts.map